classification
Title: Idle File Menu Option Improvement
Type: enhancement Stage: resolved
Components: IDLE Versions: Python 3.4, Python 3.3, Python 2.7
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: terry.reedy Nosy List: Ramchandra Apte, Todd.Rovito, python-dev, roger.serwy, taleinat, terry.reedy, tjd
Priority: normal Keywords: patch

Created on 2009-10-15 00:40 by tjd, last changed 2013-07-01 17:13 by Todd.Rovito. This issue is now closed.

Files
File name Uploaded Description Edit
IDLE_new_file_py3k.patch taleinat, 2010-07-20 15:59 review
issue7136.patch roger.serwy, 2011-12-08 04:13 extended patch review
7136FileMenuConfusionV23point4.patch Todd.Rovito, 2013-05-30 02:30 review
7136FileMenuConfusionV22point7.patch Todd.Rovito, 2013-05-30 02:43 review
Messages (12)
msg94064 - (view) Author: Toby Donaldson (tjd) Date: 2009-10-15 00:40
I've been using Idle to teach beginning programming to university
students for the last 6 or 7 years. I've taught hundreds and hundreds of
students, and the single biggest confusion with Idle is this:

"New Window" in the file menu is ambiguous

Proposed fix: change "New Window" to "New File", or "New Program"

Many beginners don't get the difference between a shell window and
program window. I spend some time explaining the difference, and yet
they see "New Window" and don't know if this means a shell window or
program window.

Obviously this is not an issue for non-beginners, or even for anyone
willing to experiment for a minute or two, but it seems to me this is a
small change that could be useful to beginners. 

Plus more precise menu options are usually a good thing in general.
msg110914 - (view) Author: Tal Einat (taleinat) * (Python committer) Date: 2010-07-20 15:59
+1 on renaming it "New File".

Patch attached for py3k.
msg149016 - (view) Author: Roger Serwy (roger.serwy) * (Python committer) Date: 2011-12-08 04:13
This issue is mentioned as part of #13504 meta-issue.

The attached patch extends Tal's original patch by also updating the help.txt documentation.
msg149023 - (view) Author: Ramchandra Apte (Ramchandra Apte) * Date: 2011-12-08 12:41
+1 on renaming New Window to New File
msg190334 - (view) Author: Todd Rovito (Todd.Rovito) * Date: 2013-05-30 02:30
Roger's patch works but the documentation has changed since he made the patch back in 2011.  So I patched the patch and hope this very simple patch will get committed.  I will work on a patch for 2.7 next.

Today I was teaching a student on how to use Python with IDLE and the student found the existing menu option confusing.  I was thrilled a patch already existed and it just needed updated.  Thanks!
msg190335 - (view) Author: Todd Rovito (Todd.Rovito) * Date: 2013-05-30 02:43
Same patch but for Python 2.7.5.  I just updated the documentation from Roger's excellent patch.
msg190337 - (view) Author: Roger Serwy (roger.serwy) * (Python committer) Date: 2013-05-30 05:16
LGTM. Thanks Todd!
msg192103 - (view) Author: Todd Rovito (Todd.Rovito) * Date: 2013-07-01 02:40
PING!!!!

It has been a month since Roger's last comment on the patch looking good, can somebody please commit or post feedback.  Thanks.
msg192106 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2013-07-01 04:18
I am planning to commit. PS. Shorter names that include '27', '33', etc, are easier to work with ;-).
msg192107 - (view) Author: Roundup Robot (python-dev) Date: 2013-07-01 04:52
New changeset 26ef5d5d5c3e by Terry Jan Reedy in branch '2.7':
Issue #7136: In the Idle File menu, "New Window" is renamed "New File".
http://hg.python.org/cpython/rev/26ef5d5d5c3e

New changeset c39ddff53694 by Terry Jan Reedy in branch '3.3':
Issue #7136: In the Idle File menu, "New Window" is renamed "New File".
http://hg.python.org/cpython/rev/c39ddff53694

New changeset 5bc3d8d22a93 by Terry Jan Reedy in branch 'default':
(merge) Issue #7136: In the Idle File menu, "New Window" is renamed "New File".
http://hg.python.org/cpython/rev/5bc3d8d22a93
msg192108 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2013-07-01 05:05
For some reason, the idlelib/help.txt was reformatted with double indents (not sure I like this) for 3.4 but not 3.3. So parts of the patch against 3.4 would not apply to 3.3, which must be patched first. And the merge to 3.4 likewise failed for two files. We should have the same text for all versions except where is actually matters. Or replace with the doc, as proposed elsewhere. 

The 'new window' issue is "Blank file editor window for a new file" versus "File editor window pre-loaded with existing file". "New file" captures the difference between the two where as "New window" is the same for both. So even native English speaker could be initially confused. When I tested, "New file" looks right. File / New may be standard on Windows, but File / New File looks fine to me.

Toby, thank you for sharing your experience. We need more of such, even if we have been slow to respond.
msg192141 - (view) Author: Todd Rovito (Todd.Rovito) * Date: 2013-07-01 17:13
Terry I am sorry the push didn't go smooth.  I thought I had checked the patch with 2.7 and 3.4 and it applied for me but maybe I missed something?  For sure I didn't check 3.3 but from here on out I will.  Awhile ago I worked on a issue to synchronize the documentation here:
http://bugs.python.org/issue5066

Mr. Andrew Svetlov was kind enough to push the patch but he only pushed it for 3.4 which I am not sure why?  Then Zachary Ware had the excellent suggestion of making the help.txt generate from the rst file http://bugs.python.org/issue16893.  So with all that being said I am confused about the direction of IDLE documentation.  Maybe we should reopen issue 5066 or create a new issue to sync help.txt and idle.rst across all version from 2.7 - 3.4? Then apply Zachary's patch to automate the creation of help.txt.
History
Date User Action Args
2013-07-01 17:13:14Todd.Rovitosetmessages: + msg192141
2013-07-01 05:06:16terry.reedysetstatus: open -> closed
resolution: fixed
stage: commit review -> resolved
2013-07-01 05:05:40terry.reedysetmessages: + msg192108
2013-07-01 04:52:43python-devsetnosy: + python-dev
messages: + msg192107
2013-07-01 04:18:45terry.reedysetassignee: roger.serwy -> terry.reedy
messages: + msg192106
2013-07-01 02:40:36Todd.Rovitosetnosy: + terry.reedy
messages: + msg192103
2013-05-30 05:16:13roger.serwysetassignee: roger.serwy
stage: needs patch -> commit review
messages: + msg190337
versions: + Python 3.3
2013-05-30 02:43:17Todd.Rovitosetfiles: + 7136FileMenuConfusionV22point7.patch

messages: + msg190335
versions: + Python 2.7
2013-05-30 02:30:09Todd.Rovitosetfiles: + 7136FileMenuConfusionV23point4.patch

messages: + msg190334
versions: + Python 3.4, - Python 3.2
2013-05-30 01:59:45Todd.Rovitosetnosy: + Todd.Rovito
2011-12-08 12:41:40Ramchandra Aptesetnosy: + Ramchandra Apte
messages: + msg149023
2011-12-08 04:13:48roger.serwysetfiles: + issue7136.patch
nosy: + roger.serwy
messages: + msg149016

2010-07-20 15:59:54taleinatsetfiles: + IDLE_new_file_py3k.patch

nosy: + taleinat
messages: + msg110914

keywords: + patch
2010-07-10 06:39:53terry.reedysetstage: needs patch
versions: + Python 3.2, - Python 2.6
2009-10-15 00:40:43tjdcreate